<?php

/**
 * Asset Element
 * @package News Show Pro GK4
 * @Copyright (C) 2009-2011 Gavick.com
 * @ All rights reserved
 * @ Joomla! is Free Software
 * @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 * @version $Revision: GK4 1.0 $
 **/
defined('JPATH_BASE') or die;

use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;


if (!function_exists('isJoomla4')) {
    function isJoomla4()
    {
        return version_compare(JVERSION, '4.0', 'ge');
    }
}

jimport('joomla.form.formfield');

class JFormFieldAsset extends JFormField
{
    protected $type = 'Asset';
    protected function getInput()
    {
        HTMLHelper::_('jquery.framework');
        $doc = Factory::getDocument();

        if (isJoomla4()) {
            $doc->addScript(Uri::root() . $this->element['path'] . 'script4.js');
        } else {
            HTMLHelper::_('behavior.framework');
            $doc->addScript(Uri::root() . $this->element['path'] . 'script.js');
        }

        $doc->addStyleSheet(Uri::root() . $this->element['path'] . 'style.css');

        if (isJoomla4()) {
            $doc->addStyleSheet(Uri::root() . $this->element['path'] . 'style4.css');
        }

        return;
    }
}
/* eof */