<?php

/**
* This Model is responsible for getting data from the com_content data source
* @package News Show Pro GK5
* @Copyright (C) 2009-2013 Gavick.com
* @ All rights reserved
* @ Joomla! is Free Software
* @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
* @version $Revision: GK5 1.3.3 $
**/

// access restriction
defined('_JEXEC') or die('Restricted access');

class NSP_GK5_rss_Model {
	// Method to get sources of articles
	static function getSources($config) {
		$content = array();
		// if there are selected files - set the variables
		if($config['rss_feed'] != '') {
			jimport('simplepie.simplepie');
			// loading file content
			$urlRss = $config['rss_feed'];
			$ch = curl_init();

			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_URL, $urlRss);

			$response = curl_exec($ch);
			curl_close($ch);

			$xml = simplexml_load_string($response);
			$json = json_encode($xml);
			$array = json_decode($json,TRUE);
			$items = $array['channel']['item'];
			//
			if(count($items) > 0) {
				//
				$art = array();
				$offset = 0;
				//
				foreach ($items as $item) {
					$enclosure = $item['enclosure'];
					$art['url'] = $item['link'] ? $item['link'] : $item['guid'];
					$art['title'] = $item['title'];
					$art['text'] = '';
					$art['date'] = '';
					$art['date_publish'] = '';
					$art['author'] = '';
					$art['catname'] = '';
					$art['category_url'] = '';
					$art['hits'] = 0;
					$art['email'] = '';
					$art['rating_sum'] = 0;
					$art['rating_count'] = 0;
					$art['image'] = $enclosure['@attributes']['url'];
					array_push($content, (array) $art);
				}
			}
		}
		//
		return $content;
	}
	// Method to get articles in standard mode 
	static function getArticles($items, $config, $amount) {	
		$content = array();
		//
		for($i = $config['offset']; $i < $amount + $config['offset']; $i++) {
			if(isset($items[$i])) {
				array_push($content, $items[$i]);
			}
		}
		// the content array
		return $content; 
	}
}

// EOF
